diff --git a/src/SybaseASE_fmt_plug.c b/src/SybaseASE_fmt_plug.c
index d6739b65f5..bbe5f17459 100644
--- a/src/SybaseASE_fmt_plug.c
+++ b/src/SybaseASE_fmt_plug.c
@@ -157,10 +157,8 @@ static int valid(char *ciphertext, struct fmt_main *self)
 {
     if(strncmp(ciphertext, "0xc007", 6)!=0)
         return 0;
-    if(strlen(ciphertext) != CIPHERTEXT_LENGTH)
+    if(hexlen(&ciphertext[6]) != CIPHERTEXT_LENGTH - 6)
         return 0;
-	if (!ishex(&ciphertext[6]))
-		return 0;
     return 1;
 }
 
diff --git a/src/SybasePROP_fmt_plug.c b/src/SybasePROP_fmt_plug.c
index 8fcb9b4c4e..637dbd2a9c 100644
--- a/src/SybasePROP_fmt_plug.c
+++ b/src/SybasePROP_fmt_plug.c
@@ -104,12 +104,9 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	if (strncmp(ciphertext, PREFIX_VALUE, PREFIX_LENGTH))
 		return 0;
 
-	if (strlen(ciphertext) != CIPHERTEXT_LENGTH)
+	if (hexlenl(p) != CIPHERTEXT_LENGTH-PREFIX_LENGTH)
 		return 0;
 
-	while (*p)
-		if (atoi16[ARCH_INDEX(*p++)] == 0x7f)
-			return 0;
 	return 1;
 }
 
diff --git a/src/md2_fmt_plug.c b/src/md2_fmt_plug.c
index cc51694a64..c90bff249e 100644
--- a/src/md2_fmt_plug.c
+++ b/src/md2_fmt_plug.c
@@ -99,11 +99,8 @@ static int valid(char *ciphertext, struct fmt_main *self)
 
 	if (!strncmp(p, FORMAT_TAG, TAG_LENGTH))
 		p += TAG_LENGTH;
-	if (strlen(p) != 32)
+	if (hexlenl(p) != 32)
 		return 0;
-	while(*p)
-		if(atoi16[ARCH_INDEX(*p++)]==0x7f)
-			return 0;
 
 	return 1;
 }
diff --git a/src/mdc2_fmt_plug.c b/src/mdc2_fmt_plug.c
index 50c6079f8c..a4054f6aef 100644
--- a/src/mdc2_fmt_plug.c
+++ b/src/mdc2_fmt_plug.c
@@ -84,18 +84,14 @@ static void done(void)
 
 static int valid(char *ciphertext, struct fmt_main *self)
 {
-	char *p, *q;
-
-	p = ciphertext;
+	char *p = ciphertext;
 
 	if (!strncmp(p, FORMAT_TAG, TAG_LENGTH))
 		p += TAG_LENGTH;
+	if (hexlenl(p) != BINARY_SIZE*2)
+		return 0;
 
-	q = p;
-	while (atoi16[ARCH_INDEX(*q)] != 0x7F)
-		q++;
-
-	return !*q && q - p == BINARY_SIZE * 2;
+	return 1;
 }
 
 static void *get_binary(char *ciphertext)
diff --git a/src/oldoffice_fmt_plug.c b/src/oldoffice_fmt_plug.c
index 1f65c1a489..9c9d15da31 100644
--- a/src/oldoffice_fmt_plug.c
+++ b/src/oldoffice_fmt_plug.c
@@ -152,11 +152,9 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*"))) /* verifier hash */
 		goto error;
-	if (res < 3 && strlen(ptr) != 32)
+	if (res < 3 && hexlen(ptr) != 32)
 		goto error;
-	if (res >= 3 && strlen(ptr) != 40)
-		goto error;
-	if (!ishex(ptr))
+	if (res >= 3 && hexlen(ptr) != 40)
 		goto error;
 	MEM_FREE(keeptr);
 	return 1;
diff --git a/src/opencl_7z_fmt_plug.c b/src/opencl_7z_fmt_plug.c
index 95ecdb57da..21ed7f1f04 100644
--- a/src/opencl_7z_fmt_plug.c
+++ b/src/opencl_7z_fmt_plug.c
@@ -337,7 +337,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL) /* iv */
 		goto err;
-	if (!ishex(p))
+	if (!ishexlc(p))
 		goto err;
 	if (strlen(p) / 2 > len && strcmp(p+len*2, "0000000000000000"))
 		goto err;
@@ -358,7 +358,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if (strlen(p) / 2 != len)	/* validates data_len atoi() */
 		goto err;
-	if (!ishex(p))
+	if (!ishexlc(p))
 		goto err;
 
 	MEM_FREE(keeptr);
diff --git a/src/opencl_agilekeychain_fmt_plug.c b/src/opencl_agilekeychain_fmt_plug.c
index 84ec7dec48..7b49f07549 100644
--- a/src/opencl_agilekeychain_fmt_plug.c
+++ b/src/opencl_agilekeychain_fmt_plug.c
@@ -233,9 +233,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 		goto err;
-	if(strlen(p) != saltlen * 2)
-		goto err;
-	if(!ishex(p))
+	if(hexlenl(p) != saltlen * 2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* ct length */
 		goto err;
@@ -246,9 +244,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* ciphertext */
 		goto err;
-	if(strlen(p) != ctlen * 2)
-		goto err;
-	if(!ishex(p))
+	if(hexlenl(p) != ctlen * 2)
 		goto err;
 
 	MEM_FREE(keeptr);
diff --git a/src/opencl_blockchain_fmt_plug.c b/src/opencl_blockchain_fmt_plug.c
index 017eb0597d..7370d10900 100644
--- a/src/opencl_blockchain_fmt_plug.c
+++ b/src/opencl_blockchain_fmt_plug.c
@@ -232,7 +232,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL)
 		goto err;
-	if (strlen(p) != len * 2 || !ishex(p))
+	if (hexlenl(p) != len * 2)
 		goto err;
 
 	MEM_FREE(keeptr);
diff --git a/src/opencl_dmg_fmt_plug.c b/src/opencl_dmg_fmt_plug.c
index fb9f2c7abf..060527a1e6 100644
--- a/src/opencl_dmg_fmt_plug.c
+++ b/src/opencl_dmg_fmt_plug.c
@@ -330,9 +330,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 			goto err;
 		if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 			goto err;
-		if (strlen(p) / 2 != res)
-			goto err;
-		if(!ishex(p))
+		if (hexlenl(p) != res*2)
 			goto err;
 		if ((p = strtokm(NULL, "*")) == NULL)	/* ivlen */
 			goto err;
@@ -343,9 +341,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 			goto err;
 		if ((p = strtokm(NULL, "*")) == NULL)	/* iv */
 			goto err;
-		if (strlen(p) / 2 != res)
-			goto err;
-		if(!ishex(p))
+		if (hexlenl(p) != res*2)
 			goto err;
 		if ((p = strtokm(NULL, "*")) == NULL)	/* encrypted_keyblob_size */
 			goto err;
@@ -356,9 +352,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 			goto err;
 		if ((p = strtokm(NULL, "*")) == NULL)	/* encrypted keyblob */
 			goto err;
-		if (strlen(p) / 2 != res)
-			goto err;
-		if(!ishex(p))
+		if (hexlenl(p) != res*2)
 			goto err;
 		if ((p = strtokm(NULL, "*")) == NULL)	/* chunk number */
 			goto err;
@@ -369,9 +363,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		res = atoi(p);
 		if ((p = strtokm(NULL, "*")) == NULL)	/* chunk */
 			goto err;
-		if (strlen(p) / 2 != res)
-			goto err;
-		if(!ishex(p))
+		if (hexlenl(p) != res*2)
 			goto err;
 		if (res > 8192)
 			goto err;
@@ -398,9 +390,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 			goto err;
 		if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 			goto err;
-		if (strlen(p) / 2 != res)
-			goto err;
-		if(!ishex(p))
+		if (hexlenl(p) != res*2)
 			goto err;
 		if ((p = strtokm(NULL, "*")) == NULL)	/* len_wrapped_aes_key */
 			goto err;
@@ -411,9 +401,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 			goto err;
 		if ((p = strtokm(NULL, "*")) == NULL)	/* wrapped_aes_key  */
 			goto err;
-		if (strlen(p) / 2 != res)
-			goto err;
-		if (!ishex(p))
+		if (hexlenl(p) != res*2)
 			goto err;
 		if ((p = strtokm(NULL, "*")) == NULL)	/* len_hmac_sha1_key */
 			goto err;
diff --git a/src/opencl_gpg_fmt_plug.c b/src/opencl_gpg_fmt_plug.c
index c2ae6218c8..03af0454c1 100644
--- a/src/opencl_gpg_fmt_plug.c
+++ b/src/opencl_gpg_fmt_plug.c
@@ -420,9 +420,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* data */
 		goto err;
-	if (strlen(p) / 2 != res)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res*2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* spec */
 		goto err;
@@ -459,9 +457,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* iv */
 		goto err;
-	if (strlen(p) != res * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res*2)
 		goto err;
 	/* handle "SPEC_SIMPLE" correctly */
 	if ((spec != 0 || usage == 255))
@@ -476,9 +472,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 		goto err;
-	if (strlen(p) != SALT_LENGTH * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != SALT_LENGTH * 2)
 		goto err;
 	/*
 	 * For some test vectors, there are no more fields,
@@ -518,9 +512,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 			goto err; // FIXME: warn if BIG_ENOUGH isn't big enough?
 		if ((p = strtokm(NULL, "*")) == NULL)
 			goto err;
-		if (strlen(p) != res * 2) /* validates res is a valid int */
-			goto err;
-		if (!ishex(p))
+		if (hexlenl(p) != res * 2) /* validates res is a valid int */
 			goto err;
 		p = strtokm(NULL, "*");  /* NOTE, do not goto err if null, we WANT p nul if there are no fields */
 	}
diff --git a/src/opencl_o5logon_fmt_plug.c b/src/opencl_o5logon_fmt_plug.c
index acb5a19e9d..289ee3f765 100644
--- a/src/opencl_o5logon_fmt_plug.c
+++ b/src/opencl_o5logon_fmt_plug.c
@@ -228,15 +228,10 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	p = strtokm(ctcopy, "*"); /* ciphertext */
 	if(!p)
 		goto err;
-	if(strlen(p) != CIPHERTEXT_LENGTH * 2)
-		goto err;
-	if (!ishex(p))
-		goto err;
+	if(hexlenl(p) != CIPHERTEXT_LENGTH * 2)
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 		goto err;
-	if(strlen(p) != SALT_LENGTH * 2)
-		goto err;
-	if (!ishex(p))
+	if(hexlenl(p) != SALT_LENGTH * 2)
 		goto err;
 	MEM_FREE(keeptr);
 	return 1;
diff --git a/src/opencl_odf_aes_fmt_plug.c b/src/opencl_odf_aes_fmt_plug.c
index 78e42b05ae..ebfdb6a525 100644
--- a/src/opencl_odf_aes_fmt_plug.c
+++ b/src/opencl_odf_aes_fmt_plug.c
@@ -239,9 +239,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* iv */
 		goto err;
-	if (strlen(p) != res * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res * 2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt length */
 		goto err;
@@ -250,9 +248,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 		goto err;
-	if (strlen(p) != res * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res * 2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* something */
 		goto err;
@@ -261,7 +257,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	res = strlen(p);
 	if (res > 2048 || res & 1)
 		goto err;
-	if (!ishex(p))
+	if (!ishexlc(p))
 		goto err;
 
 	MEM_FREE(keeptr);
diff --git a/src/opencl_odf_fmt_plug.c b/src/opencl_odf_fmt_plug.c
index c3c6691413..d3e304ed44 100644
--- a/src/opencl_odf_fmt_plug.c
+++ b/src/opencl_odf_fmt_plug.c
@@ -243,9 +243,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* iv */
 		goto err;
-	if (strlen(p) != res * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res * 2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt length */
 		goto err;
@@ -254,9 +252,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 		goto err;
-	if (strlen(p) != res * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res * 2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* something */
 		goto err;
@@ -265,7 +261,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	res = strlen(p);
 	if (res > 2048 || res & 1)
 		goto err;
-	if (!ishex(p))
+	if (!ishexlc(p))
 		goto err;
 
 	MEM_FREE(keeptr);
diff --git a/src/opencl_oldoffice_fmt_plug.c b/src/opencl_oldoffice_fmt_plug.c
index 8a19d766a6..d8097948b4 100644
--- a/src/opencl_oldoffice_fmt_plug.c
+++ b/src/opencl_oldoffice_fmt_plug.c
@@ -270,23 +270,17 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*"))) /* salt */
 		goto error;
-	if (strlen(ptr) != 32)
-		goto error;
-	if (!ishex(ptr))
+	if (hexlen(ptr) != 32)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*"))) /* verifier */
 		goto error;
-	if (strlen(ptr) != 32)
-		goto error;
-	if (!ishex(ptr))
+	if (hexlen(ptr) != 32)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*"))) /* verifier hash */
 		goto error;
-	if (res < 3 && strlen(ptr) != 32)
-		goto error;
-	if (res >= 3 && strlen(ptr) != 40)
+	if (res < 3 && hexlen(ptr) != 32)
 		goto error;
-	if (!ishex(ptr))
+	if (res >= 3 && hexlen(ptr) != 40)
 		goto error;
 	MEM_FREE(keeptr);
 	return 1;
diff --git a/src/oracle11_fmt_plug.c b/src/oracle11_fmt_plug.c
index 16aed76f0f..c067714166 100644
--- a/src/oracle11_fmt_plug.c
+++ b/src/oracle11_fmt_plug.c
@@ -163,12 +163,7 @@ static void done(void)
 
 static int valid(char *ciphertext, struct fmt_main *self)
 {
-	int i;
-
-	for (i = 0; i < CIPHERTEXT_LENGTH; i++)
-		if (atoi16[ARCH_INDEX(ciphertext[i])] == 0x7F)
-			return 0;
-	return !ciphertext[i];
+	return hexlenu(ciphertext)==CIPHERTEXT_LENGTH;
 }
 
 static void *get_salt(char *ciphertext)
diff --git a/src/panama_fmt_plug.c b/src/panama_fmt_plug.c
index e35c3c6f0e..08847c9904 100644
--- a/src/panama_fmt_plug.c
+++ b/src/panama_fmt_plug.c
@@ -98,12 +98,8 @@ static int valid(char *ciphertext, struct fmt_main *self)
 
 	if (!strncmp(p, FORMAT_TAG, TAG_LENGTH))
 		p += TAG_LENGTH;
-	if (strlen(p) != BINARY_SIZE*2)
+	if (hexlenl(p) != BINARY_SIZE*2)
 		return 0;
-	while(*p)
-		if(atoi16[ARCH_INDEX(*p++)]==0x7f)
-			return 0;
-
 	return 1;
 }
 
diff --git a/src/postgres_fmt_plug.c b/src/postgres_fmt_plug.c
index d1170128fa..4ca830bffb 100644
--- a/src/postgres_fmt_plug.c
+++ b/src/postgres_fmt_plug.c
@@ -109,14 +109,14 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	/* Check hash */
 	if (!(p = strrchr(ciphertext, '*')))
 		return 0;
-	if (strspn(&p[1], HEXCHARS_all) != 2*BINARY_SIZE)
+	if (hexlenl(&p[1]) != 2*BINARY_SIZE)
 		return 0;
 
 	/* Check salt */
 	p -= 9;
 	if (*p != '*')
 		return 0;
-	if (strspn(&p[1], HEXCHARS_all) != 8)
+	if (abs(hexlenl(&p[1])) != 8)
 		return 0;
 
 	/* Check username length */
diff --git a/src/putty_fmt_plug.c b/src/putty_fmt_plug.c
index 7c0c8cf4c4..11057b0a2d 100644
--- a/src/putty_fmt_plug.c
+++ b/src/putty_fmt_plug.c
@@ -158,9 +158,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* public_blob */
 		goto err;
-	if (strlen(p) != res * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res * 2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* private_blob_len */
 		goto err;
@@ -171,9 +169,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* private_blob */
 		goto err;
-	if (strlen(p) != res * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res * 2)
 		goto err;
 	if (!is_old_fmt) {
 		if ((p = strtokm(NULL, "*")) == NULL)	/* alg */
diff --git a/src/racf_fmt_plug.c b/src/racf_fmt_plug.c
index 68c69452ad..4abcb01a1b 100644
--- a/src/racf_fmt_plug.c
+++ b/src/racf_fmt_plug.c
@@ -169,8 +169,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 {
 	char *ctcopy;
 	char *keeptr;
-	char *p, *q;
-	int res;
+	char *p;
 	if (strncmp(ciphertext, "$racf$*", 7))
 		return 0;
 	ctcopy = strdup(ciphertext);
@@ -181,13 +180,10 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* hash */
 		goto err;
-	q = p;
-	while (atoi16[ARCH_INDEX(*q)] != 0x7F)
-		q++;
-
-	res = !*q && q - p == CIPHERTEXT_LENGTH;
+	if (hexlenu(p) != CIPHERTEXT_LENGTH)
+		goto err;
 	MEM_FREE(keeptr);
-	return res;
+	return 1;
 
 err:
 	MEM_FREE(keeptr);
diff --git a/src/radmin_fmt_plug.c b/src/radmin_fmt_plug.c
index ff91bc7ed9..c88b738b20 100644
--- a/src/radmin_fmt_plug.c
+++ b/src/radmin_fmt_plug.c
@@ -88,15 +88,20 @@ static void done(void)
 	MEM_FREE(crypt_out);
 }
 
+static char *split(char *ciphertext, int index, struct fmt_main *self) {
+	static char buf[CIPHERTEXT_LENGTH + 10];   // $radmin2$ is 9 bytes
+	strnzcpy(buf, ciphertext, CIPHERTEXT_LENGTH + 10);
+	strlwr(buf);
+	return buf;
+}
+
 static int valid(char *ciphertext, struct fmt_main *self)
 {
 	char *p;
 	if (strncmp(ciphertext, "$radmin2$", 9))
 		return 0;
 	p = ciphertext + 9;
-	if (strlen(p) != CIPHERTEXT_LENGTH)
-		return 0;
-	if (!ishex(p))
+	if (hexlen(p) != CIPHERTEXT_LENGTH)
 		return 0;
 	return 1;
 }
@@ -196,7 +201,7 @@ struct fmt_main fmt_radmin = {
 		SALT_ALIGN,
 		MIN_KEYS_PER_CRYPT,
 		MAX_KEYS_PER_CRYPT,
-		FMT_CASE | FMT_8_BIT | FMT_OMP | FMT_OMP_BAD,
+		FMT_CASE | FMT_8_BIT | FMT_OMP | FMT_OMP_BAD | FMT_SPLIT_UNIFIES_CASE,
 		{ NULL },
 		radmin_tests
 	}, {
@@ -205,7 +210,7 @@ struct fmt_main fmt_radmin = {
 		fmt_default_reset,
 		fmt_default_prepare,
 		valid,
-		fmt_default_split,
+		split,
 		get_binary,
 		fmt_default_salt,
 		{ NULL },
diff --git a/src/rar5_common.h b/src/rar5_common.h
index 00bcb5265d..e51815e61b 100644
--- a/src/rar5_common.h
+++ b/src/rar5_common.h
@@ -77,9 +77,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL) // salt
 		goto err;
-	if (strlen(p) != len * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != len * 2)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL) // iterations (in log2)
 		goto err;
@@ -91,9 +89,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL) // AES IV
 		goto err;
-	if (strlen(p) != SIZE_INITV * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != SIZE_INITV * 2)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL) // pswcheck len (redundant)
 		goto err;
@@ -103,9 +99,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL) // pswcheck
 		goto err;
-	if (strlen(p) != BINARY_SIZE * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != BINARY_SIZE * 2)
 		goto err;
 
 	MEM_FREE(keeptr);
diff --git a/src/snefru_fmt_plug.c b/src/snefru_fmt_plug.c
index 69d990e63c..f097dab8a1 100644
--- a/src/snefru_fmt_plug.c
+++ b/src/snefru_fmt_plug.c
@@ -103,13 +103,9 @@ static int valid(char *ciphertext, struct fmt_main *self, int len)
 
 	if (!strncmp(p, FORMAT_TAG, TAG_LENGTH))
 		p += TAG_LENGTH;
-	if (strlen(p) != len)
+	if (hexlenl(p) != len)
 		return 0;
 
-	while(*p)
-		if(atoi16[ARCH_INDEX(*p++)]==0x7f)
-			return 0;
-
 	return 1;
 }
 
@@ -340,8 +336,7 @@ struct fmt_main fmt_snefru_128 = {
 		MIN_KEYS_PER_CRYPT,
 		MAX_KEYS_PER_CRYPT,
 		FMT_CASE | FMT_8_BIT | FMT_OMP,
-		{ NULL },
-		snefru_128_tests
+		{ NULL },snefru_128_tests
 	}, {
 		init,
 		done,
diff --git a/src/ssh_ng_fmt_plug.c b/src/ssh_ng_fmt_plug.c
index 0f39a32208..bde72a4af4 100644
--- a/src/ssh_ng_fmt_plug.c
+++ b/src/ssh_ng_fmt_plug.c
@@ -112,6 +112,14 @@ static void done(void)
 	MEM_FREE(saved_key);
 }
 
+static char *split(char *ciphertext, int index, struct fmt_main *self)
+{
+	static char buf[sizeof(struct custom_salt)+100];
+	strnzcpy(buf, ciphertext, sizeof(buf));
+	strlwr(buf);
+	return buf;
+}
+
 static int valid(char *ciphertext, struct fmt_main *self)
 {
 	char *ctcopy, *keeptr, *p;
@@ -135,9 +143,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL)	/* salt */
 		goto err;
-	if (strlen(p) != len * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlen(p) != len * 2)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL)	/* ciphertext length */
 		goto err;
@@ -146,9 +152,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	len = atoi(p);
 	if ((p = strtokm(NULL, "$")) == NULL)	/* ciphertext */
 		goto err;
-	if (strlen(p) / 2 != len)
-		goto err;
-	if (!ishex(p))
+	if (hexlen(p) / 2 != len)
 		goto err;
 	if (cipher == 2) {
 		if ((p = strtokm(NULL, "$")) == NULL)	/* rounds */
@@ -478,7 +482,7 @@ struct fmt_main fmt_sshng = {
 		SALT_ALIGN,
 		MIN_KEYS_PER_CRYPT,
 		MAX_KEYS_PER_CRYPT,
-		FMT_CASE | FMT_8_BIT | FMT_OMP | FMT_NOT_EXACT,
+		FMT_CASE | FMT_8_BIT | FMT_OMP | FMT_NOT_EXACT | FMT_SPLIT_UNIFIES_CASE,
 		{ NULL },
 		sshng_tests
 	}, {
@@ -487,7 +491,7 @@ struct fmt_main fmt_sshng = {
 		fmt_default_reset,
 		fmt_default_prepare,
 		valid,
-		fmt_default_split,
+		split,
 		fmt_default_binary,
 		get_salt,
 		{ NULL },
diff --git a/src/strip_fmt_plug.c b/src/strip_fmt_plug.c
index 2cc6852477..a7a628a164 100644
--- a/src/strip_fmt_plug.c
+++ b/src/strip_fmt_plug.c
@@ -109,9 +109,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	ctcopy += 7+1;	/* skip over "$strip$" and first '*' */
 	if ((p = strtokm(ctcopy, "*")) == NULL)	/* salt + data */
 		goto err;
-	if (strlen(p) != 2048)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != 2048)
 		goto err;
 
 	MEM_FREE(keeptr);
diff --git a/src/sxc_fmt_plug.c b/src/sxc_fmt_plug.c
index bca67dcc13..4855b8476e 100644
--- a/src/sxc_fmt_plug.c
+++ b/src/sxc_fmt_plug.c
@@ -136,9 +136,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* checksum field (skipped) */
 		goto err;
-	if (strlen(p) != BINARY_SIZE * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != BINARY_SIZE * 2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* iv length */
 		goto err;
@@ -147,9 +145,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* iv */
 		goto err;
-	if (strlen(p) != res * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res * 2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt length */
 		goto err;
@@ -158,9 +154,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 		goto err;
-	if (strlen(p) != res * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res * 2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* original length */
 		goto err;
@@ -174,9 +168,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* content */
 		goto err;
-	if (strlen(p) != res * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res * 2)
 		goto err;
 	if (strtokm(NULL, "*") != NULL)	        /* the end */
 		goto err;
diff --git a/src/vnc_fmt_plug.c b/src/vnc_fmt_plug.c
index 30b5263c11..82f6817f13 100644
--- a/src/vnc_fmt_plug.c
+++ b/src/vnc_fmt_plug.c
@@ -160,11 +160,11 @@ static int valid(char *ciphertext, struct fmt_main *self)
 
 	if (!(ptr = strtokm(ctcopy, "*")))
 		goto error;
-	if (strlen(ptr) != 32 || !ishex(ptr))
+	if (hexlenu(ptr) != 32)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*")))
 		goto error;
-	if (strlen(ptr) != 32 || !ishex(ptr))
+	if (hexlenu(ptr) != 32)
 		goto error;
 	MEM_FREE(keeptr);
 	return 1;
diff --git a/src/wbb3_fmt_plug.c b/src/wbb3_fmt_plug.c
index c3fe436f78..ee03d5af76 100644
--- a/src/wbb3_fmt_plug.c
+++ b/src/wbb3_fmt_plug.c
@@ -125,15 +125,11 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 		goto err;
-	if (!ishex(p))
-		goto err;
-	if (strlen(p) > 40)
+	if (hexlenl(p) > 40)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* hash */
 		goto err;
-	if (strlen(p) != BINARY_SIZE * 2)
-		goto err;
-	if(!ishex(p))
+	if (hexlenl(p) != BINARY_SIZE * 2)
 		goto err;
 
 	return 1;
diff --git a/src/whirlpool_fmt_plug.c b/src/whirlpool_fmt_plug.c
index e885483223..97d819995e 100644
--- a/src/whirlpool_fmt_plug.c
+++ b/src/whirlpool_fmt_plug.c
@@ -109,9 +109,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 
 	if (!strncmp(p, FORMAT_TAG, TAG_LENGTH))
 		p += TAG_LENGTH;
-	if (strlen(p) != CIPHERTEXT_LENGTH)
-		return 0;
-	if (!ishex(p))
+	if (hexlen(p) != CIPHERTEXT_LENGTH)
 		return 0;
 
 	return 1;
